%3-d straight-ray earthquake location Exercise 5, Chapter 9 (constant velocity medium)

clear;

%
%Global vars
%
global d;
global staloc;
global vel;
global sigma;

%Data noise in s (as given)
sigma=0.001;

%half-space velocity (m/s)
vel=2000;

%load data and staloc
load eqdata.mat

%number of sources and earthquakes
[NSTA,NSOURCE]=size(data);

%Initial Guesses at solution
pest0 = [0;0;-200;0];

%maximum LM iterations
MAXITER=50;

%loop over the earthquakes
for nev=1:NSOURCE

%extract the data for this earthquake
d=data(:,nev);
%and find this event's hypocentral solution
[pest,iter]=lm('fun','jac',pest0,1e-12,MAXITER);

%estimate solution covariance for this solution using the final Jacobian
Jest=jac(pest);

%covariance estimate
cov = inv(Jest'*Jest);

%store the results for this earthquake
xx(:,nev)=pest;
%standard deviations from the diagonal of the covariance matrix
xxstd(:,nev)=sqrt(diag(cov));
end

%plot the locations
figure(1)
plot3(xx(1,:),xx(2,:),xx(3,:),'g*');
grid
hold on
plot3(staloc(:,1),staloc(:,2),staloc(:,3),'o');
xlabel('x (m)');
ylabel('y (m)');
zlabel('z (m)');
axis([-500 500 -500 500 -300 0 ]);
hold off
print -deps eqresults.eps

disp(['Location Results: ev# , x , y , z (m), t0 (s), sigx , sigy , sigz (m), sigt0 (s)']);
sprintf('%d %6.2f %6.2f %6.2f %6.2f %6.2f %6.2f %6.3f %6.3f\n',[ (1:nev)' , xx' , xxstd']')





